View Issue Details

IDProjectCategoryView StatusLast Update
0000499Pgpool-IIBugpublic2019-04-19 07:37
ReporterrwesolowskiAssigned Tot-ishii 
PrioritynormalSeverityminorReproducibilityalways
Status resolvedResolutionopen 
Product Version4.0.2 
Target Version4.0.5Fixed in Version 
Summary0000499: Connection to PGPool-II Fails to return results in case of error
DescriptionI ran into an issue that I'm not totally sure how to fix.
We are using PGPool-II 4.0.2 / PostgreSQL 11 to do all of our communication to the DB. Our configurations demand that all services go through PGPool-II. Anyways the issue I'm seeing is that if I connect to the Postgres instance directly, everything works well the application is working in case of any error, but if i attempt to connect thought PGPool-II the connection to application is frozen and all functionalities are not available. The problem is that when we have such error then the application can become broken at all (in all places where we use pgpool2) instead of just have some error only in one place. We are using Node.js v10.15.0 and connecting to PostgreSQL using: https://github.com/balderdashy/sails-postgresql to connect to pgpool/postgresql

Here is an error:

postgresql/node_modules/pg/lib/connection.js:105:22)
at Socket.emit (events.js:182:13)
at Socket.EventEmitter.emit (domain.js:441:20)
at addChunk (_stream_readable.js:283:12)
at readableAddChunk (_stream_readable.js:264:11)
at Socket.Readable.push (_stream_readable.js:219:10)
at TCP.onStreamRead [as onread] (internal/stream_base_commons.js:94:17)
name: 'error',
length: 99,
severity: 'ERROR',
code: 'XX000',
detail: 'not enough space in buffer',
hint: undefined,
position: undefined,
internalPosition: undefined,
internalQuery: undefined,
where: undefined,
schema: undefined,
table: undefined,
column: undefined,
dataType: undefined,
constraint: undefined,
file: 'pool_process_query.c',
line: '4339',
routine: undefined },
isOperational: true,
length: 99,
severity: 'ERROR',
code: 'XX000',
detail: 'not enough space in buffer',
hint: undefined,
position: undefined,
internalPosition: undefined,
internalQuery: undefined,
where: undefined,
schema: undefined,
table: undefined,
column: undefined,
dataType: undefined,
constraint: undefined,
file: 'pool_process_query.c',
line: '4339',
routine: undefined }

pgpool.conf:

# ----------------------------
# pgPool-II configuration file
# ----------------------------
#
# This file consists of lines of the form:
#
# name = value
#
# Whitespace may be used. Comments are introduced with "#" anywhere on a line.
# The complete list of parameter names and allowed values can be found in the
# pgPool-II documentation.
#
# This file is read on server startup and when the server receives a SIGHUP
# signal. If you edit the file on a running system, you have to SIGHUP the
# server for the changes to take effect, or use "pgpool reload". Some
# parameters, which are marked below, require a server shutdown and restart to
# take effect.
#


#------------------------------------------------------------------------------
# CONNECTIONS
#------------------------------------------------------------------------------

# - pgpool Connection Settings -

listen_addresses = '*'
                                   # Host name or IP address to listen on:
                                   # '*' for all, '' for no TCP/IP connections
                                   # (change requires restart)
port = 9999
                                   # Port number
                                   # (change requires restart)
socket_dir = '/var/run/postgresql'
                                   # Unix domain socket path
                                   # The Debian package defaults to
                                   # /var/run/postgresql
                                   # (change requires restart)


# - pgpool Communication Manager Connection Settings -

pcp_listen_addresses = '*'
                                   # Host name or IP address for pcp process to listen on:
                                   # '*' for all, '' for no TCP/IP connections
                                   # (change requires restart)
pcp_port = 9898
                                   # Port number for pcp
                                   # (change requires restart)
pcp_socket_dir = '/var/run/postgresql'
                                   # Unix domain socket path for pcp
                                   # The Debian package defaults to
                                   # /var/run/postgresql
                                   # (change requires restart)
listen_backlog_multiplier = 2
                                   # Set the backlog parameter of listen(2) to
                                   # num_init_children * listen_backlog_multiplier.
                                   # (change requires restart)
serialize_accept = off
                                   # whether to serialize accept() call to avoid thundering herd problem
                                   # (change requires restart)

# - Backend Connection Settings -

backend_hostname0 = 'stage-edw01.cpp.1ux.it'
                                   # Host name or IP address to connect to for backend 0
backend_port0 = 5432
                                   # Port number for backend 0
backend_weight0 = 1
                                   # Weight for backend 0 (only in load balancing mode)
backend_data_directory0 = '/var/lib/postgresql/11/main'
                                   # Data directory for backend 0
backend_flag0 = 'ALLOW_TO_FAILOVER'
                                   # Controls various backend behavior
                                   # ALLOW_TO_FAILOVER, DISALLOW_TO_FAILOVER
                   # or ALWAYS_MASTER
backend_hostname1 = 'stage-edw02.cpp.1ux.it'
backend_port1 = 5432
backend_weight1 = 1
backend_data_directory1 = '/var/lib/postgresql/11/main'
backend_flag1 = 'ALLOW_TO_FAILOVER'

# - Authentication -

enable_pool_hba = on
                                   # Use pool_hba.conf for client authentication
pool_passwd = 'pool_passwd'
                                   # File name of pool_passwd for md5 authentication.
                                   # "" disables pool_passwd.
                                   # (change requires restart)
authentication_timeout = 60
                                   # Delay in seconds to complete client authentication
                                   # 0 means no timeout.

# - SSL Connections -

ssl = off
                                   # Enable SSL support
                                   # (change requires restart)
#ssl_key = './server.key'
                                   # Path to the SSL private key file
                                   # (change requires restart)
#ssl_cert = './server.cert'
                                   # Path to the SSL public certificate file
                                   # (change requires restart)
#ssl_ca_cert = ''
                                   # Path to a single PEM format file
                                   # containing CA root certificate(s)
                                   # (change requires restart)
#ssl_ca_cert_dir = ''
                                   # Directory containing CA root certificate(s)
                                   # (change requires restart)


#------------------------------------------------------------------------------
# POOLS
#------------------------------------------------------------------------------

# - Concurrent session and pool size -

num_init_children = 100
                                   # Number of concurrent sessions allowed
                                   # (change requires restart)
max_pool = 4
                                   # Number of connection pool caches per connection
                                   # (change requires restart)

# - Life time -

child_life_time = 300
                                   # Pool exits after being idle for this many seconds
child_max_connections = 0
                                   # Pool exits after receiving that many connections
                                   # 0 means no exit
connection_life_time = 0
                                   # Connection to backend closes after being idle for this many seconds
                                   # 0 means no close
client_idle_limit = 0
                                   # Client is disconnected after being idle for that many seconds
                                   # (even inside an explicit transactions!)
                                   # 0 means no disconnection


#------------------------------------------------------------------------------
# LOGS
#------------------------------------------------------------------------------

# - Where to log -

log_destination = 'stderr'
                                   # Where to log
                                   # Valid values are combinations of stderr,
                                   # and syslog. Default to stderr.

# - What to log -

log_line_prefix = '%t: pid %p: ' # printf-style string to output at beginning of each log line.

log_connections = on
                                   # Log connections
log_hostname = off
                                   # Hostname will be shown in ps status
                                   # and in logs if connections are logged
log_statement = off
                                   # Log all statements
log_per_node_statement = off
                                   # Log all statements
                                   # with node and backend informations
log_standby_delay = 'if_over_threshold'
                                   # Log standby delay
                                   # Valid values are combinations of always,
                                   # if_over_threshold, none

# - Syslog specific -

syslog_facility = 'LOCAL0'
                                   # Syslog local facility. Default to LOCAL0
syslog_ident = 'pgpool'
                                   # Syslog program identification string
                                   # Default to 'pgpool'

# - Debug -

log_error_verbosity = default # terse, default, or verbose messages

client_min_messages = log # values in order of decreasing detail:
                                        # debug5
                                        # debug4
                                        # debug3
                                        # debug2
                                        # debug1
                                        # log
                                        # notice
                                        # warning
                                        # error

log_min_messages = warning # values in order of decreasing detail:
                                        # debug5
                                        # debug4
                                        # debug3
                                        # debug2
                                        # debug1
                                        # info
                                        # notice
                                        # warning
                                        # error
                                        # log
                                        # fatal
                                        # panic

#------------------------------------------------------------------------------
# FILE LOCATIONS
#------------------------------------------------------------------------------

pid_file_name = '/var/run/postgresql/pgpool.pid'
                                   # PID file name
                                   # Can be specified as relative to the"
                                   # location of pgpool.conf file or
                                   # as an absolute path
                                   # (change requires restart)
logdir = '/tmp'
                                   # Directory of pgPool status file
                                   # (change requires restart)


#------------------------------------------------------------------------------
# CONNECTION POOLING
#------------------------------------------------------------------------------

connection_cache = on
                                   # Activate connection pools
                                   # (change requires restart)

                                   # Semicolon separated list of queries
                                   # to be issued at the end of a session
                                   # The default is for 8.3 and later
reset_query_list = 'ABORT; DISCARD ALL'
                                   # The following one is for 8.2 and before
#reset_query_list = 'ABORT; RESET ALL; SET SESSION AUTHORIZATION DEFAULT'


#------------------------------------------------------------------------------
# REPLICATION MODE
#------------------------------------------------------------------------------

replication_mode = off
                                   # Activate replication mode
                                   # (change requires restart)
replicate_select = off
                                   # Replicate SELECT statements
                                   # when in replication mode
                                   # replicate_select is higher priority than
                                   # load_balance_mode.

insert_lock = off
                                   # Automatically locks a dummy row or a table
                                   # with INSERT statements to keep SERIAL data
                                   # consistency
                                   # Without SERIAL, no lock will be issued
lobj_lock_table = ''
                                   # When rewriting lo_creat command in
                                   # replication mode, specify table name to
                                   # lock

# - Degenerate handling -

replication_stop_on_mismatch = off
                                   # On disagreement with the packet kind
                                   # sent from backend, degenerate the node
                                   # which is most likely "minority"
                                   # If off, just force to exit this session

failover_if_affected_tuples_mismatch = off
                                   # On disagreement with the number of affected
                                   # tuples in UPDATE/DELETE queries, then
                                   # degenerate the node which is most likely
                                   # "minority".
                                   # If off, just abort the transaction to
                                   # keep the consistency


#------------------------------------------------------------------------------
# LOAD BALANCING MODE
#------------------------------------------------------------------------------

load_balance_mode = on
                                   # Activate load balancing mode
                                   # (change requires restart)
ignore_leading_white_space = on
                                   # Ignore leading white spaces of each query
white_function_list = ''
                                   # Comma separated list of function names
                                   # that don't write to database
                                   # Regexp are accepted
black_function_list = 'currval,lastval,nextval,setval,refresh_mv,aws_lambda_assessment_superstrong,aws_lambda_assessment_cpi'
                                   # Comma separated list of function names
                                   # that write to database
                                   # Regexp are accepted

database_redirect_preference_list = ''
                                   # comma separated list of pairs of database and node id.
                                   # example: postgres:primary,mydb[0-4]:1,mydb[5-9]:2'
                                   # valid for streaming replicaton mode only.

app_name_redirect_preference_list = ''
                                   # comma separated list of pairs of app name and node id.
                                   # example: 'psql:primary,myapp[0-4]:1,myapp[5-9]:standby'
                                   # valid for streaming replicaton mode only.
allow_sql_comments = off
                                   # if on, ignore SQL comments when judging if load balance or
                                   # query cache is possible.
                                   # If off, SQL comments effectively prevent the judgment
                                   # (pre 3.4 behavior).

#------------------------------------------------------------------------------
# MASTER/SLAVE MODE
#------------------------------------------------------------------------------

master_slave_mode = on
                                   # Activate master/slave mode
                                   # (change requires restart)
master_slave_sub_mode = 'stream'
                                   # Master/slave sub mode
                                   # Valid values are combinations stream, slony
                                   # or logical. Default is stream.
                                   # (change requires restart)

# - Streaming -

sr_check_period = 5
                                   # Streaming replication check period
                                   # Disabled (0) by default
sr_check_user = 'postgres'
                                   # Streaming replication check user
                                   # This is neccessary even if you disable streaming
                                   # replication delay check by sr_check_period = 0
sr_check_password = '{6rk#+\#xu$TA5R>'
                                   # Password for streaming replication check user
sr_check_database = 'postgres'
                                   # Database name for streaming replication check
delay_threshold = 10000000
                                   # Threshold before not dispatching query to standby node
                                   # Unit is in bytes
                                   # Disabled (0) by default

# - Special commands -

follow_master_command = ''
                                   # Executes this command after master failover
                                   # Special values:
                                   # %d = node id
                                   # %h = host name
                                   # %p = port number
                                   # %D = database cluster path
                                   # %m = new master node id
                                   # %H = hostname of the new master node
                                   # %M = old master node id
                                   # %P = old primary node id
                                   # %r = new master port number
                                   # %R = new master database cluster path
                                   # %% = '%' character

#------------------------------------------------------------------------------
# HEALTH CHECK GLOBAL PARAMETERS
#------------------------------------------------------------------------------

health_check_period = 5
                                   # Health check period
                                   # Disabled (0) by default
health_check_timeout = 0
                                   # Health check timeout
                                   # 0 means no timeout
health_check_user = 'postgres'
                                   # Health check user
health_check_password = '{6rk#+\#xu$TA5R>'
                                   # Password for health check user
health_check_database = 'honeybadger_stage'
                                   # Database name for health check. If '', tries 'postgres' frist,
health_check_max_retries = 0
                                   # Maximum number of times to retry a failed health check before giving up.
health_check_retry_delay = 1
                                   # Amount of time to wait (in seconds) between retries.
connect_timeout = 10000
                                   # Timeout value in milliseconds before giving up to connect to backend.
                                   # Default is 10000 ms (10 second). Flaky network user may want to increase
                                   # the value. 0 means no timeout.
                                   # Note that this value is not only used for health check,
                                   # but also for ordinary conection to backend.

#------------------------------------------------------------------------------
# HEALTH CHECK PER NODE PARAMETERS (OPTIONAL)
#------------------------------------------------------------------------------
health_check_period0 = 0
health_check_timeout0 = 20
health_check_user0 = 'nobody'
health_check_password0 = ''
health_check_database0 = ''
health_check_max_retries0 = 0
health_check_retry_delay0 = 1
connect_timeout0 = 10000

#------------------------------------------------------------------------------
# FAILOVER AND FAILBACK
#------------------------------------------------------------------------------

failover_command = '/etc/pgpool2/4.0.2/failover.sh %d %P %H "A4*YRzN2j#&BL!&j" /etc/postgresql/11/main/im_the_master'
                                   # Executes this command at failover
                                   # Special values:
                                   # %d = node id
                                   # %h = host name
                                   # %p = port number
                                   # %D = database cluster path
                                   # %m = new master node id
                                   # %H = hostname of the new master node
                                   # %M = old master node id
                                   # %P = old primary node id
                                   # %r = new master port number
                                   # %R = new master database cluster path
                                   # %% = '%' character
failback_command = ''
                                   # Executes this command at failback.
                                   # Special values:
                                   # %d = node id
                                   # %h = host name
                                   # %p = port number
                                   # %D = database cluster path
                                   # %m = new master node id
                                   # %H = hostname of the new master node
                                   # %M = old master node id
                                   # %P = old primary node id
                                   # %r = new master port number
                                   # %R = new master database cluster path
                                   # %% = '%' character

failover_on_backend_error = on
                                   # Initiates failover when reading/writing to the
                                   # backend communication socket fails
                                   # If set to off, pgpool will report an
                                   # error and disconnect the session.

search_primary_node_timeout = 300
                                   # Timeout in seconds to search for the
                                   # primary node when a failover occurs.
                                   # 0 means no timeout, keep searching
                                   # for a primary node forever.

#------------------------------------------------------------------------------
# ONLINE RECOVERY
#------------------------------------------------------------------------------

recovery_user = 'postgres'
                                   # Online recovery user
recovery_password = '{6rk#+\#xu$TA5R>'
                                   # Online recovery password
recovery_1st_stage_command = 'recovery_1st_stage.sh'
                                   # Executes a command in first stage
recovery_2nd_stage_command = ''
                                   # Executes a command in second stage
recovery_timeout = 90
                                   # Timeout in seconds to wait for the
                                   # recovering node's postmaster to start up
                                   # 0 means no wait
client_idle_limit_in_recovery = 0
                                   # Client is disconnected after being idle
                                   # for that many seconds in the second stage
                                   # of online recovery
                                   # 0 means no disconnection
                                   # -1 means immediate disconnection


#------------------------------------------------------------------------------
# WATCHDOG
#------------------------------------------------------------------------------

# - Enabling -

use_watchdog = off
                                    # Activates watchdog
                                    # (change requires restart)

# -Connection to up stream servers -

trusted_servers = 'build-edw01.cpp.1ux.it,prod-edw02.cpp.1ux.it'
                                    # trusted server list which are used
                                    # to confirm network connection
                                    # (hostA,hostB,hostC,...)
                                    # (change requires restart)
ping_path = '/bin'
                                    # ping command path
                                    # (change requires restart)

# - Watchdog communication Settings -

wd_hostname =''
                                    # Host name or IP address of this watchdog
                                    # (change requires restart)
wd_port = 9000
                                    # port number for watchdog service
                                    # (change requires restart)
wd_priority = 2
                                    # priority of this watchdog in leader election
                                    # (change requires restart)

wd_authkey = ''
                                    # Authentication key for watchdog communication
                                    # (change requires restart)

wd_ipc_socket_dir = '/var/run/postgresql'
                                    # Unix domain socket path for watchdog IPC socket
                                    # The Debian package defaults to
                                    # /var/run/postgresql
                                    # (change requires restart)


# - Virtual IP control Setting -

delegate_IP = ''
                                    # delegate IP address
                                    # If this is empty, virtual IP never bring up.
                                    # (change requires restart)
if_cmd_path = '/bin'
                                    # path to the directory where if_up/down_cmd exists
                                    # (change requires restart)
if_up_cmd = 'ip_w addr add $_IP_$/24 dev eth0 label eth0:1'
                                    # startup delegate IP command
                                    # (change requires restart)
if_down_cmd = 'ip_w addr del $_IP_$/24 dev eth0'
                                    # shutdown delegate IP command
                                    # (change requires restart)
arping_path = '/usr/bin'
                                    # arping command path
                                    # (change requires restart)
arping_cmd = 'arping_w -U $_IP_$ -w 1'
                                    # arping command
                                    # (change requires restart)

# - Behaivor on escalation Setting -

clear_memqcache_on_escalation = on
                                    # Clear all the query cache on shared memory
                                    # when standby pgpool escalate to active pgpool
                                    # (= virtual IP holder).
                                    # This should be off if client connects to pgpool
                                    # not using virtual IP.
                                    # (change requires restart)
wd_escalation_command = ''
                                    # Executes this command at escalation on new active pgpool.
                                    # (change requires restart)
wd_de_escalation_command = ''
                                    # Executes this command when master pgpool resigns from being master.
                                    # (change requires restart)

# - Watchdog consensus settings for failover -

failover_when_quorum_exists = on
                                    # Only perform backend node failover
                                    # when the watchdog cluster holds the quorum
                                    # (change requires restart)

failover_require_consensus = on
                                    # Perform failover when majority of Pgpool-II nodes
                                    # aggrees on the backend node status change
                                    # (change requires restart)

allow_multiple_failover_requests_from_node = off
                                    # A Pgpool-II node can cast multiple votes
                                    # for building the consensus on failover
                                    # (change requires restart)


# - Lifecheck Setting -

# -- common --

wd_monitoring_interfaces_list = '' # Comma separated list of interfaces names to monitor.
                                    # if any interface from the list is active the watchdog will
                                    # consider the network is fine
                                    # 'any' to enable monitoring on all interfaces except loopback
                                    # '' to disable monitoring
                                    # (change requires restart)

wd_lifecheck_method = 'heartbeat'
                                    # Method of watchdog lifecheck ('heartbeat' or 'query' or 'external')
                                    # (change requires restart)
wd_interval = 3
                                    # lifecheck interval (sec) > 0
                                    # (change requires restart)

# -- heartbeat mode --

wd_heartbeat_port = 9694
                                    # Port number for receiving heartbeat signal
                                    # (change requires restart)
wd_heartbeat_keepalive = 2
                                    # Interval time of sending heartbeat signal (sec)
                                    # (change requires restart)
wd_heartbeat_deadtime = 30
                                    # Deadtime interval for heartbeat signal (sec)
                                    # (change requires restart)
heartbeat_destination0 = 'stage-edw02.cpp.1ux.it'
                                    # Host name or IP address of destination 0
                                    # for sending heartbeat signal.
                                    # (change requires restart)
heartbeat_destination_port0 = 9694
                                    # Port number of destination 0 for sending
                                    # heartbeat signal. Usually this is the
                                    # same as wd_heartbeat_port.
                                    # (change requires restart)
heartbeat_device0 = ''
                                    # Name of NIC device (such like 'eth0')
                                    # used for sending/receiving heartbeat
                                    # signal to/from destination 0.
                                    # This works only when this is not empty
                                    # and pgpool has root privilege.
                                    # (change requires restart)

#heartbeat_destination1 = 'host0_ip2'
#heartbeat_destination_port1 = 9694
#heartbeat_device1 = ''

# -- query mode --

wd_life_point = 3
                                    # lifecheck retry times
                                    # (change requires restart)
wd_lifecheck_query = 'SELECT 1'
                                    # lifecheck query to pgpool from watchdog
                                    # (change requires restart)
wd_lifecheck_dbname = 'honeybadger_stage'
                                    # Database name connected for lifecheck
                                    # (change requires restart)
wd_lifecheck_user = 'nobody'
                                    # watchdog user monitoring pgpools in lifecheck
                                    # (change requires restart)
wd_lifecheck_password = ''
                                    # Password for watchdog user in lifecheck
                                    # (change requires restart)

# - Other pgpool Connection Settings -

other_pgpool_hostname0 = ''
                                    # Host name or IP address to connect to for other pgpool 0
                                    # (change requires restart)
other_pgpool_port0 = 9999
                                    # Port number for othet pgpool 0
                                    # (change requires restart)
other_wd_port0 = 9000
                                    # Port number for othet watchdog 0
                                    # (change requires restart)
#other_pgpool_hostname1 = 'host1'
#other_pgpool_port1 = 5432
#other_wd_port1 = 9000


#------------------------------------------------------------------------------
# OTHERS
#------------------------------------------------------------------------------
relcache_expire = 0
                                   # Life time of relation cache in seconds.
                                   # 0 means no cache expiration(the default).
                                   # The relation cache is used for cache the
                                   # query result against PostgreSQL system
                                   # catalog to obtain various information
                                   # including table structures or if it's a
                                   # temporary table or not. The cache is
                                   # maintained in a pgpool child local memory
                                   # and being kept as long as it survives.
                                   # If someone modify the table by using
                                   # ALTER TABLE or some such, the relcache is
                                   # not consistent anymore.
                                   # For this purpose, cache_expiration
                                   # controls the life time of the cache.
relcache_size = 256
                                   # Number of relation cache
                                   # entry. If you see frequently:
                                   # "pool_search_relcache: cache replacement happend"
                                   # in the pgpool log, you might want to increate this number.

check_temp_table = on
                                   # If on, enable temporary table check in SELECT statements.
                                   # This initiates queries against system catalog of primary/master
                                   # thus increases load of master.
                                   # If you are absolutely sure that your system never uses temporary tables
                                   # and you want to save access to primary/master, you could turn this off.
                                   # Default is on.

check_unlogged_table = on
                                   # If on, enable unlogged table check in SELECT statements.
                                   # This initiates queries against system catalog of primary/master
                                   # thus increases load of master.
                                   # If you are absolutely sure that your system never uses unlogged tables
                                   # and you want to save access to primary/master, you could turn this off.
                                   # Default is on.

#------------------------------------------------------------------------------
# IN MEMORY QUERY MEMORY CACHE
#------------------------------------------------------------------------------
memory_cache_enabled = off
                                   # If on, use the memory cache functionality, off by default
memqcache_method = 'shmem'
                                   # Cache storage method. either 'shmem'(shared memory) or
                                   # 'memcached'. 'shmem' by default
                                   # (change requires restart)
memqcache_memcached_host = 'localhost'
                                   # Memcached host name or IP address. Mandatory if
                                   # memqcache_method = 'memcached'.
                                   # Defaults to localhost.
                                   # (change requires restart)
memqcache_memcached_port = 11211
                                   # Memcached port number. Mondatory if memqcache_method = 'memcached'.
                                   # Defaults to 11211.
                                   # (change requires restart)
memqcache_total_size = 67108864
                                   # Total memory size in bytes for storing memory cache.
                                   # Mandatory if memqcache_method = 'shmem'.
                                   # Defaults to 64MB.
                                   # (change requires restart)
memqcache_max_num_cache = 1000000
                                   # Total number of cache entries. Mandatory
                                   # if memqcache_method = 'shmem'.
                                   # Each cache entry consumes 48 bytes on shared memory.
                                   # Defaults to 1,000,000(45.8MB).
                                   # (change requires restart)
memqcache_expire = 0
                                   # Memory cache entry life time specified in seconds.
                                   # 0 means infinite life time. 0 by default.
                                   # (change requires restart)
memqcache_auto_cache_invalidation = on
                                   # If on, invalidation of query cache is triggered by corresponding
                                   # DDL/DML/DCL(and memqcache_expire). If off, it is only triggered
                                   # by memqcache_expire. on by default.
                                   # (change requires restart)
memqcache_maxcache = 409600
                                   # Maximum SELECT result size in bytes.
                                   # Must be smaller than memqcache_cache_block_size. Defaults to 400KB.
                                   # (change requires restart)
memqcache_cache_block_size = 1048576
                                   # Cache block size in bytes. Mandatory if memqcache_method = 'shmem'.
                                   # Defaults to 1MB.
                                   # (change requires restart)
memqcache_oiddir = '/var/log/pgpool/oiddir'
                                      # Temporary work directory to record table oids
                                   # (change requires restart)
white_memqcache_table_list = ''
                                   # Comma separated list of table names to memcache
                                   # that don't write to database
                                   # Regexp are accepted
black_memqcache_table_list = ''
                                   # Comma separated list of table names not to memcache
                                   # that don't write to database
                                   # Regexp are accepted
Steps To ReproduceUse sails-postgresql to connect to pgpool and postgresql and execute function statement which return error:

ERROR in PostgreSQL
"ERROR: structure of query does not match function result type
DETAIL: Returned type timestamp with time zone does not match expected type timestamp without time zone in column 3.
CONTEXT: PL/pgSQL function vitanavis.testitemlist(uuid) line 4 at RETURN QUERY

Pgpool:
"LOG: pool_send_and_wait: Error or notice message from backend: : DB node id: 0 backend pid: 10208 statement: "select * from app.get_data('8c1d951a-f2f3-4a75-bf5f-2d2e9543c57d', 'en-US);" message: "structure of query does not match function result
ERROR: unable to detect error
DETAIL: not enough space in buffer"
Additional InformationUbuntu 14.04.6 LTS (GNU/Linux 3.13.0-132-generic x86_64)
PostgreSQL 11
PGPool-II 4.0.2
We are using streaming replication
 Node.js v10.15.0
Tagspgpool-II

Activities

t-ishii

2019-04-17 08:11

developer   ~0002561

It seems Pgpool-II fails to parse an error message returned from PostgreSQL. Can you share the PostgreSQL error message?

rwesolowski

2019-04-17 16:12

reporter   ~0002562

It is long error:
ERROR: structure of query does not match function result type
DETAIL: Returned type timestamp with time zone does not match expected type timestamp without time zone in column 3.
CONTEXT: PL/pgSQL function vitanavis.testitemlist(uuid) line 4 at RETURN QUERY
SQL statement "WITH assessment AS (SELECT assessmentguid, assessmentitemgroupsortorder, assessmentinstructions, assessmentItemGroupRandomize
                    FROM vitanavis.tbl_app_assessments
                    WHERE assessmentguid = p_assessment
                   ),

/* testAssessment */

testassessment as( select a.assessmentguid, a.testassessment as testassessmentguid , b.assessmentitemgroupsortorder,b.assessmentinstructions , b.assessmentItemGroupRandomize
             , assessmentitemgroupsortorder1 as itemgroupguid
             FROM vitanavis.testitemlist(p_assessment) a
            JOIN vitanavis.tbl_app_assessments b ON a.testassessment = b.assessmentguid , LATERAL unnest(assessmentitemgroupsortorder) as assessmentitemgroupsortorder1
                  where testassessment in (SELECT unnest(p_testassessmentguid::uuid[])))
,
/* Sub-query - grab item groups */
itemgroups AS (SELECT itemgroupguid , itemgroupinstructions, itemgroupitemsortorder, itemgrouprandomizeitems
               FROM vitanavis.tbl_app_itemgroup
               WHERE itemgroupguid in (SELECT unnest(assessmentitemgroupsortorder) from assessment)
              ) ,
            
/* Sub-query - grab testitem groups */
testitemgroups AS (SELECT itemgroupguid , itemgroupinstructions, itemgroupitemsortorder, itemgrouprandomizeitems
               FROM vitanavis.tbl_app_itemgroup
               WHERE itemgroupguid in (SELECT unnest(assessmentitemgroupsortorder) from testassessment)
              ) ,
                          
/* Sub query - grab assessment instructions */
instructions as ( SELECT case when instructionstranslations ? p_lang then jsonb_build_object(p_lang,instructionstranslations->>p_lang)
                else jsonb_build_object(p_lang,instructionstranslations->>'en-US') end instructionstranslations, instructionsguid
                 FROM vitanavis.tbl_app_instructions
                 WHERE instructionsguid in (SELECT unnest(assessmentinstructions) from assessment) and respondent=p_respondent
                 UNION
                 SELECT case when instructionstranslations ? p_lang then jsonb_build_object(p_lang,instructionstranslations->>p_lang)
                else jsonb_build_object(p_lang,instructionstranslations->>'en-US') end instructionstranslations, instructionsguid
                 FROM vitanavis.tbl_app_instructions
                 WHERE instructionsguid in (SELECT unnest(itemgroupinstructions) from itemgroups) and respondent=p_respondent )
                
                ,
                          
/* Sub query - grab assessment instructions */
testinstructions as ( SELECT case when instructionstranslations ? p_lang then jsonb_build_object(p_lang,instructionstranslations->>p_lang)
                else jsonb_build_object(p_lang,instructionstranslations->>'en-US') end instructionstranslations, instructionsguid
                 FROM vitanavis.tbl_app_instructions
                 WHERE instructionsguid in (SELECT unnest(assessmentinstructions) from testassessment) and respondent=p_respondent
                 UNION
                 SELECT case when instructionstranslations ? p_lang then jsonb_build_object(p_lang,instructionstranslations->>p_lang)
                else jsonb_build_object(p_lang,instructionstranslations->>'en-US') end instructionstranslations, instructionsguid
                 FROM vitanavis.tbl_app_instructions
                 WHERE instructionsguid in (SELECT unnest(itemgroupinstructions) from testitemgroups) and respondent=p_respondent )
                
                ,
/* Sub-query, grab item table */
item AS (SELECT itemguid,itemresponse, itemforminput, itemlinkedto, itemFormInputOptions, itemtranslationguid
               FROM vitanavis.tbl_app_item
               WHERE itemguid in (SELECT unnest(itemgroupitemsortorder::uuid[]) from itemgroups)
              ),
         
/* Sub-query, grab testitem table */
testitem AS (SELECT itemguid,itemresponse, itemforminput, itemlinkedto, itemFormInputOptions, itemtranslationguid
               FROM vitanavis.tbl_app_item
               WHERE itemguid in (SELECT unnest(itemgroupitemsortorder::uuid[] ) from testitemgroups)
              )
    

/******************************************************************************/
/* Query create JSON */
/******************************************************************************/
    SELECT jsonb_object_agg(all_data.assessmentguid, all_data) FROM (
    SELECT A.*,
           /* Create the itemgroups */
            ( SELECT jsonb_object_agg(itemgroups_aggs.itemgroupguid, itemgroups_aggs)
             FROM ( SELECT itemgroupguid , itemgroupinstructions , itemgrouprandomizeitems, itemgroupitemsortorder
                    FROM vitanavis.tbl_app_itemgroup AS B
                    WHERE B.itemgroupguid = ANY(A.assessmentitemgroupsortorder)
                   ) AS itemgroups_aggs
           ) itemgroups,
           /* Create the instructions */
           ( SELECT jsonb_object_agg(instructions.instructionsguid, instructions)
             FROM ( SELECT case when instructionstranslations ? p_lang then jsonb_build_object(p_lang,instructionstranslations->>p_lang)
                else jsonb_build_object(p_lang,instructionstranslations->>'en-US') end instructionstranslations, instructionsguid,respondent
                     FROM vitanavis.tbl_app_instructions
                     WHERE instructionsguid in (SELECT unnest(assessmentinstructions) from assessment) and respondent=p_respondent
                     UNION
                     SELECT case when instructionstranslations ? p_lang then jsonb_build_object(p_lang,instructionstranslations->>p_lang)
                else jsonb_build_object(p_lang,instructionstranslations->>'en-US') end instructionstranslations, instructionsguid, respondent
                     FROM vitanavis.tbl_app_instructions
                     WHERE instructionsguid in (SELECT unnest(itemgroupinstructions) from itemgroups) and respondent=p_respondent
                
                --and (instructionstranslations ->> p_lang) is not null
                                              ) AS instructions
           ) instruction,
           /* Items */
             ( SELECT jsonb_object_agg(item.itemguid, item)
             FROM (SELECT case when itemtranslation ? p_lang then jsonb_build_object(p_lang,itemtranslation->>p_lang)
ELSE jsonb_build_object(p_lang,itemtranslation->>'en-US') end itemtranslations,b.itemguid, respondent, itemresponse,itemforminput, itemlinkedto, itemFormInputOptions
                   FROM vitanavis.tbl_app_itemtranslation a join item b on a.itemtranslationguid=b.itemtranslationguid
                   WHERE a.itemtranslationguid in (SELECT itemtranslationguid from item) and respondent=p_respondent
                          
                   ) AS item
           ) items,
             /* Responses */
    (select jsonb_object_agg( response.responsegroupguid, response )from
           ( select responsegroupguid, jsonb_agg(responsegroupitems ORDER BY nr) as responsegroupitems from (
                select responsegroupguid, nr,responseorder,case when responsegroupitems->'content' ? p_lang
                                                then responsegroupitems_1 else responsegroupitems_2 end responsegroupitems from (
 select responsegroupguid,nr,responseorder,jsonb_array_elements(responsegroupitems) as responsegroupitems ,
    jsonb_build_object('value' , jsonb_array_elements(responsegroupitems)->'value','content', jsonb_build_object(p_lang,jsonb_array_elements(responsegroupitems)->'content'->p_lang)
                    ,'options', jsonb_strip_nulls(jsonb_build_object('disableOther',jsonb_array_elements(responsegroupitems)->'options'->'disableOther'))) as responsegroupitems_1,
    jsonb_build_object('value' , jsonb_array_elements(responsegroupitems)->'value','content', jsonb_build_object(p_lang,jsonb_array_elements(responsegroupitems)->'content'->'en-US')
                    ,'options', jsonb_strip_nulls(jsonb_build_object('disableOther',jsonb_array_elements(responsegroupitems)->'options'->'disableOther'))) as responsegroupitems_2
     from ( select responsegroupguid,a.elem as responseorder, a.nr, responsegroupitems from vitanavis.tbl_app_responsegroup t , unnest(t.responsegrouporder) WITH ORDINALITY a(elem, nr)
    where responsegroupguid in (SELECT itemresponse from item) )x

                                                                                    ) zz where responseorder = (responsegroupitems->>'value')::int )z
 group by responsegroupguid order by 1
           ) response ) responses,
            /*TestItems */
        (Select jsonb_object_agg(testitems.testassessmentguid,testitems) as testitems from (
    SELECT C.*, testitem,
               /* CustomItems */

           /* Create the itemgroups */
            ( SELECT jsonb_object_agg(itemgroups_aggs.itemgroupguid, itemgroups_aggs)
             FROM ( SELECT itemgroupguid , itemgroupinstructions , itemgrouprandomizeitems, itemgroupitemsortorder
                    FROM vitanavis.tbl_app_itemgroup AS B
                    WHERE B.itemgroupguid = ANY(C.assessmentitemgroupsortorder)
                   ) AS itemgroups_aggs
           ) itemgroups ,
           /* Create the instructions */
           ( SELECT jsonb_object_agg(instructions.instructionsguid, instructions)
             FROM ( SELECT case when instructionstranslations ? p_lang then jsonb_build_object(p_lang,instructionstranslations->>p_lang)
                else jsonb_build_object(p_lang,instructionstranslations->>'en-US') end instructionstranslations, instructionsguid,respondent
                     FROM vitanavis.tbl_app_instructions
                     WHERE instructionsguid in (SELECT unnest(assessmentinstructions) from testassessment) and respondent=p_respondent
                     UNION
                      SELECT case when instructionstranslations ? p_lang then jsonb_build_object(p_lang,instructionstranslations->>p_lang)
                else jsonb_build_object(p_lang,instructionstranslations->>'en-US') end instructionstranslations, instructionsguid, respondent
                     FROM vitanavis.tbl_app_instructions
                     WHERE instructionsguid in (SELECT unnest(itemgroupinstructions) from testitemgroups) and respondent=p_respondent
                
                --and (instructionstranslations ->> 'en-US') is not null
                                              ) AS instructions
           ) instruction,

             /* Responses */
    (select jsonb_object_agg( response.responsegroupguid, response )from
           ( select responsegroupguid, jsonb_agg(responsegroupitems ORDER BY nr) as responsegroupitems from (
                select responsegroupguid, nr,responseorder,case when responsegroupitems->'content' ? p_lang
                                                then responsegroupitems_1 else responsegroupitems_2 end responsegroupitems from (
 select responsegroupguid,nr,responseorder,jsonb_array_elements(responsegroupitems) as responsegroupitems ,
    jsonb_build_object('value' , jsonb_array_elements(responsegroupitems)->'value','content', jsonb_build_object(p_lang,jsonb_array_elements(responsegroupitems)->'content'->p_lang)
                    ,'options', jsonb_strip_nulls(jsonb_build_object('disableOther',jsonb_array_elements(responsegroupitems)->'options'->'disableOther'))) as responsegroupitems_1,
    jsonb_build_object('value' , jsonb_array_elements(responsegroupitems)->'value','content', jsonb_build_object(p_lang,jsonb_array_elements(responsegroupitems)->'content'->'en-US')
                    ,'options', jsonb_strip_nulls(jsonb_build_object('disableOther',jsonb_array_elements(responsegroupitems)->'options'->'disableOther'))) as responsegroupitems_2
     from ( select responsegroupguid,a.elem as responseorder, a.nr, responsegroupitems from vitanavis.tbl_app_responsegroup t , unnest(t.responsegrouporder) WITH ORDINALITY a(elem, nr)
    where responsegroupguid in (SELECT itemresponse from item) )x

                                                                                    ) zz where responseorder = (responsegroupitems->>'value')::int )z
 group by responsegroupguid order by 1
           ) response ) responses
        
       FROM testassessment C LEFT JOIN LATERAL (select jsonb_object_agg(itemguid, item) as testitem FROM (
                 SELECT itemgroupguid,case when itemtranslation ? p_lang then jsonb_build_object(p_lang,itemtranslation->>p_lang)
ELSE jsonb_build_object(p_lang,itemtranslation->>'en-US') end itemtranslations,b.itemguid, respondent, itemresponse,itemforminput, itemlinkedto, itemFormInputOptions
                   FROM testitemgroups C ,LATERAL unnest(itemgroupitemsortorder) as itemgroupitemsortorder1
                    join testitem b on itemgroupitemsortorder1 = b.itemguid
                   join vitanavis.tbl_app_itemtranslation a on a.itemtranslationguid=b.itemtranslationguid
                   WHERE respondent=p_respondent
                    
                          
                  ) AS item where itemgroupguid = C.itemgroupguid group by itemgroupguid )
 testitem on true ) testitems )
        
    FROM assessment AS A
) AS all_data"
PL/pgSQL function app.get_data(uuid,character varying,character varying,boolean,uuid[]) line 188 at SQL statement
SQL state: 42804

t-ishii

2019-04-17 22:48

developer   ~0002566

Your query definitely does not fit in the fixed size buffer (8192 bytes) in Pgpool-II. So I have fixed it by using dynamically allocated buffer. For 4.0 stable branch, here is the commit.
https://git.postgresql.org/gitweb/?p=pgpool2.git;a=commit;h=51131a2132b52f1030917f108b8e3e60d3a4009f
Can you please try it out?

rwesolowski

2019-04-18 23:39

reporter   ~0002570

it works on our site as we expect. Thank you very much!

t-ishii

2019-04-19 07:37

developer   ~0002571

Great! I am going to mark this issue as "resolved".

Issue History

Date Modified Username Field Change
2019-04-17 00:27 rwesolowski New Issue
2019-04-17 00:27 rwesolowski Tag Attached: pgpool-II
2019-04-17 08:11 t-ishii Note Added: 0002561
2019-04-17 16:12 rwesolowski Note Added: 0002562
2019-04-17 22:44 t-ishii Assigned To => t-ishii
2019-04-17 22:44 t-ishii Status new => assigned
2019-04-17 22:48 t-ishii Note Added: 0002566
2019-04-17 22:48 t-ishii Status assigned => feedback
2019-04-17 22:48 t-ishii Target Version => 4.0.5
2019-04-18 23:39 rwesolowski Note Added: 0002570
2019-04-18 23:39 rwesolowski Status feedback => assigned
2019-04-19 07:37 t-ishii Note Added: 0002571
2019-04-19 07:37 t-ishii Status assigned => resolved